package com.evasion.components
{
	import spark.components.SkinnableContainer;
	import com.evasion.data.User;
	
	import flash.events.MouseEvent;
	import mx.messaging.channels.AMFChannel;
        import mx.messaging.ChannelSet;
	import mx.controls.Alert;
	import mx.events.FlexEvent;
	import mx.rpc.remoting.RemoteObject; 
        import mx.rpc.events.ResultEvent; 
        import mx.rpc.events.FaultEvent; 
	
	import com.evasion.skins.LoginSkin;
	
	import spark.components.Button;
	import spark.components.SkinnableContainer;
	import spark.components.TextInput;

        import mx.core.FlexGlobals;

	import com.evasion.dto.StaticPage;
	
	public class Login extends SkinnableContainer
	{
		[SkinPart(required="true")] public var loginTxt:TextInput;
		[SkinPart(required="true")] public var passwordTxt:TextInput;
		[SkinPart(required="true")] public var connectBt:Button;
		
		private var _data:User;
		
                public var staticpageRO:RemoteObject; 
		
                public var staticpage:StaticPage; 
				
		// Constructeur
		public function Login()
		{
			super();
			_data = new User();
			setStyle("skinClass",LoginSkin);
			addEventListener(FlexEvent.CREATION_COMPLETE, initComponent);
		}
		
		// Methodes
		
		public function get data():User
		{
			return _data;
		}
		public function set data(value:User):void
		{
			_data = value;
		}
		
		private function initComponent(pEvent:FlexEvent):void{
			useRemoteObject();
			connectBt.addEventListener(MouseEvent.CLICK, connectUser);
			loginTxt.text = _data.name;
			passwordTxt.text = _data.password;
		}
		
		private function connectUser(pEvent:MouseEvent):void{
			//Alert.show("login : " + loginTxt.text + " // " + passwordTxt.text);
			//Alert.show("Object : " + staticpageRO);
			staticpageRO.getStaticPage(1);
			Alert.show("Titre : " + staticpage.titre);
			
		}
		
		public function useRemoteObject():void { 
			staticpageRO = new RemoteObject();
                        var _channelSet:ChannelSet = new ChannelSet();
			var _amfChannel:AMFChannel = new AMFChannel("my-amf", FlexGlobals.topLevelApplication.parameters.urlBlazeDs);
			_channelSet.addChannel(_amfChannel);


			staticpageRO.destination = "staticPageEJB"; 
			staticpageRO.getStaticPage.addEventListener("result", getListResultHandler); 
			staticpageRO.addEventListener("fault", faultHandler); 
			staticpageRO.channelSet = _channelSet;
		} 
		
		public function getListResultHandler(event:ResultEvent):void { 
			// Do something 
			Alert.show("Object : " + event.result);
			staticpage=event.result as StaticPage;

		} 
		
		public function faultHandler (event:FaultEvent):void { 
			// Deal with event.fault.faultString, etc. 
			Alert.show(event.fault.faultString + " "+ event.fault.getStackTrace(), 'Error'); 
		}
	}
}